import * as _google_cloud_logging_build_src_entry from '@google-cloud/logging/build/src/entry';
import * as firebase_firestore from 'firebase/firestore';
import { Firestore } from 'firebase/firestore';
import * as _usereactify_taskify from '@usereactify/taskify';
import { StackAny, TaskDefinition, GetTaskDefinition, GetInputSchema, GetContextSchema, Task, TaskStatus } from '@usereactify/taskify';
import { WithRef } from '@usereactify/app';
import React from 'react';
import { FirebaseApp } from 'firebase/app';
import { Functions } from 'firebase/functions';

declare const useDispatchTask: <Stack extends StackAny, TDefName extends keyof _usereactify_taskify.GetTaskDefinitions<Stack>, TDef extends TaskDefinition = GetTaskDefinition<Stack, TDefName>>(stackName: Stack["stackName"], taskDefinitionName: TDefName) => (input?: GetInputSchema<TDef> | undefined, context?: GetContextSchema<TDef> | undefined) => Promise<{
    taskPath: string;
}>;
declare const useTask: (taskPath?: string) => {
    task: WithRef<Task> | undefined;
    loading: boolean;
    error: firebase_firestore.FirestoreError | undefined;
};
declare const useRetryTask: () => ({ originalTaskPath }: {
    originalTaskPath: string;
}) => Promise<{
    taskPath: string;
}>;
declare const useTaskLogs: ({ taskPath, searchFromDate, }: {
    taskPath: string;
    searchFromDate: Date;
}) => {
    status: "NO_LOGS_FOUND" | "LOGS_FOUND" | "EMULATOR" | undefined;
    logEntries: {
        insertId: string;
        severity: _google_cloud_logging_build_src_entry.LogSeverity;
        message: string;
        timestamp: string;
    }[] | undefined;
};

declare type Context = {
    firestore: Firestore;
    functions: Functions;
    firebase: FirebaseApp;
    viewTask: (args: {
        taskPath: string;
    }) => void;
};
declare const Context: React.Context<Context | null>;
interface Props {
    region: string;
    firebase: FirebaseApp;
    children: React.ReactNode;
}
declare const TaskifyProvider: React.FC<Props>;
declare const useContext: () => Context;
declare const useFirebase: () => FirebaseApp;
declare const useFirestore: () => Firestore;
declare const useFunctions: () => Functions;
declare const useViewTask: () => (args: {
    taskPath: string;
}) => void;

interface TaskListProps {
    tasksPath?: string;
}
declare const TaskList: React.FC<TaskListProps>;

declare const TaskModal: React.FC<{
    open: boolean;
    taskPath?: string;
    onClose: () => void;
}>;

declare const LogViewer: React.FC<{
    task: WithRef<Task>;
}>;

declare const StatusBadge: React.FC<{
    status: TaskStatus;
}>;

export { Context, LogViewer, StatusBadge, TaskList, TaskListProps, TaskModal, TaskifyProvider, useContext, useDispatchTask, useFirebase, useFirestore, useFunctions, useRetryTask, useTask, useTaskLogs, useViewTask };
